---
title: ServiceWorkerMessageEvent
slug: Web/API/ServiceWorkerMessageEvent
tags:
  - API
  - Deprecated
  - Experimental
  - Interface
  - Offline
  - Référence(2)
  - Service Workers
  - ServiceWorkerMessageEvent
  - Workers
---
<div>{{APIRef("Service Workers API")}}{{deprecated_header}}</div>

<div class="warning">
<p><strong>Important</strong>: In modern browsers, this interface has been deprecated. Service worker messages will now use the {{domxref("MessageEvent")}} interface, for consistency with other web messaging features.</p>
</div>

<p>The <strong><code>ServiceWorkerMessageEvent</code></strong> interface of the {{domxref("ServiceWorker_API", "ServiceWorker API")}} contains information about an event sent to a {{domxref("ServiceWorkerContainer")}} target. This extends the default {{event("message")}} event to allow setting a {{domxref("ServiceWorker")}} object as the source of a message. The event object is accessed via the handler function of a {{event("message_(ServiceWorker)","message")}} event, when fired by a message received from a service worker.</p>

<p>This interface inherits from the {{domxref("Event")}} interface.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ServiceWorkerMessageEvent.ServiceWorkerMessageEvent()")}} {{deprecated_inline}}</dt>
 <dd>Creates a new <code>ServiceWorkerMessageEvent</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, </em><em>{{domxref("Event")}}</em>.</p>

<dl>
 <dt>{{domxref("ServiceWorkerMessageEvent.data")}} {{readonlyinline}} {{deprecated_inline}}</dt>
 <dd>Returns the event's data. It can be any data type.</dd>
 <dt>{{domxref("ServiceWorkerMessageEvent.origin")}} {{readonlyinline}} {{deprecated_inline}}</dt>
 <dd>Returns the origin of the service worker's environment settings object.</dd>
 <dt>{{domxref("ServiceWorkerMessageEvent.lastEventId")}} {{readonlyinline}} {{deprecated_inline}}</dt>
 <dd>Represents, in <a href="en-US/docs/Server-sent_events/Using_server-sent_events">server-sent events</a>, the last event ID of the event source.</dd>
 <dt>{{domxref("ServiceWorkerMessageEvent.source")}} {{readonlyinline}} {{deprecated_inline}}</dt>
 <dd>Returns a reference to the service worker that sent the message.</dd>
 <dt>{{domxref("ServiceWorkerMessageEvent.ports")}} {{readonlyinline}} {{deprecated_inline}}</dt>
 <dd>Returns an array of {{domxref("MessagePort")}} objects.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, </em><em>{{domxref("Event")}}</em>.</p>

<h2 id="Examples">Examples</h2>

<p>When the following code is used inside the main thread to set up a message channel between it and a service worker for sending messages between the two, the event object of <code>onmessage</code> will be a <code>ServiceWorkerMessageEvent</code>.</p>

<pre class="brush: js">navigator.serviceWorker.ready.then(function(reg) {

  ...

      // set up a message channel to communicate with the SW
      var channel = new MessageChannel();
      channel.port1.onmessage = function(e) {
        console.log(e);
        handleChannelMessage(e.data);
      }

      mySW = reg.active;
      mySW.postMessage('hello', [channel.port2]);
  });</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerMessageEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Using web workers</a></li>
</ul>
